/**
         * 日历
         * @type {Object}
         */
        var ht = [];
        var Calendar = {
            settings:{
                firstDayOfWeek: 1,  //每周第一天是周一
                baseClass: "",  //默认的样式
                curDayClass: "ub ub-ac ub-pc currDay", //当天的样式
                prevMonthCellClass: "ub ub-ver ub-ac ub-pc td-wh tc_95",  //上一个月按钮样式
                nextMonthCellClass: "ub ub-ver ub-ac ub-pc td-wh tc_95",  //下一个月的按钮样式
                curMonthNormalCellClass: "ub ub-ver ub-ac ub-pc td-wh",   //当前月每天样式
                prevNextMonthDaysVisible: true  //是否显示上个月和下个月的日期
            },
            containerId: "",  //日期id
            weekDayNames: [], //每周天数名字
            Init: function(weekDayNames, dateLinkMappings, settings) {  //初始化相应日期链接和添加每周天数名字
                if (!weekDayNames || weekDayNames.length && weekDayNames.length != 7) {
                    //this.weekDayNames[0] = "日";
                    this.weekDayNames[1] = "一";
                    this.weekDayNames[2] = "二";
                    this.weekDayNames[3] = "三";
                    this.weekDayNames[4] = "四";
                    this.weekDayNames[5] = "五";
                    this.weekDayNames[6] = "六";
                    this.weekDayNames[7] = "日";
                } else {
                    this.weekDayNames = weekDayNames;
                }
            },
            RenderCalendar: function(divId, month, year, dataJson) {  //日历部分
                month = Number(month); 
                year = Number(year);
                this.containerId = divId;
                var ht = [];
         
                ht.push('<div id="calendar_box" class="ub ub-ver">');
                ht.push(this._RenderTitle(month, year, dataJson));
                ht.push(this._RenderBody(month, year, dataJson));
                ht.push("</div>");
        
                document.getElementById(divId).innerHTML = ht.join("");
                // this._InitEvent(divId, month, year, dataJson);
            },
            _RenderTitle: function(month, year, dataJson) {  //日历标题
                var ht = [];
                //日期
                ht.push("<div id='title' class='ub ub-ac ub-pc uh t-wht umar-t'>");
                // ht.push("<div id='", this.containerId, "_prevMonth' style='margin-right: 5%;'><div class='icon-left date_icon_hw'></div></div>");
                ht.push("<div class='ut ub ub-ac ub-pc ut-s tx-c bold ulev-3 tc' id='dateTool' onclick='changeYmonth()'>");
                ht.push("<span id='ymonth'>"+year+(month<10?"-0"+month:"-"+month)+"</span></div>");
                ht.push("<div class='ub' id='dateTool'><div class='date_choose date_choose_hw'></div></div></div>");
                ht.push("<div class='ub' style='position: absolute;top: 1em;right: 7.5%;'><div class='icon-rllist1 date_icon_hw'></div></div></div>");
                //星期
                ht.push('<div id="calendar_th" class="ub ub-ac ub-pj" style="margin: 0 5%;">');
                for (var i = 0; i < 7; i++) {
                    var day = (i + this.settings.firstDayOfWeek) == 7 ? 7 : (i + this.settings.firstDayOfWeek) % 7;
                    ht.push("<div class='ub ub-ac ub-pc ub-f1 ub-fv'><div<div class='ub ub-ver ub-ac ub-pc td-wht'><span>", this.weekDayNames[day], '</span></div>');
                }
                ht.push("</div></div>");
                return ht.join("");
            },
            _RenderBody: function(month, year, dataJson) {  //天
                var date = new Date(year, month - 1, 1); //当月第一天
                var day = date.getDay();  //当月第一天在一周是第几天(星期几)
                var dayOfMonth = 1;
                var daysOfPrevMonth = (7 - this.settings.firstDayOfWeek + day) % 7;  //需要显示上个月的天数
                var totalDays = this._GetTotalDays(month, year);  //当月总天数
                var totalDaysOfPrevMonth = this._GetToalDaysOfPrevMonth(month, year);  //下个月总天数
                var ht = [];
                var curDate; //当前日期
                var currMonthDay; //当前月日
                
                ht.push('<div id="calendar_td" class="">');
                for (var i = 0; ; i++) {
                    curDate = null;
                    if (i % 7 == 0) {//新起一行
                        ht.push('<div id="calendar_tdline" class="ub ub-ac h2" style="margin: 2.5% 5% 2.5% 5%">');
                    }
                    
                    ht.push("<div");
                    if (i >= daysOfPrevMonth && dayOfMonth <= totalDays) {//本月
                        curDate = new Date(year, month - 1, dayOfMonth);
                        currMonthDay = year+"-"+(curDate.getMonth()+1)+"-"+curDate.getDate();
                        currDay = curDate.getDate();
                        ht.push(showDayInfo(currMonthDay,dataJson[dayOfMonth-1]));
                        //console.log(showDayInfo(currMonthDay))
                        dayOfMonth++;
                    } else if (i < daysOfPrevMonth) {//上月
                        if (this.settings.prevNextMonthDaysVisible) {
                            var prevMonth = month;
                            var prevYear = year;
                            if (month == 1) {
                                prevMonth = 12;
                                prevYear = prevYear - 1;
                            }
                            else {
                                prevMonth = prevMonth - 1;
                            }
                            curDate = new Date(prevYear, prevMonth - 1, totalDaysOfPrevMonth - (daysOfPrevMonth - i - 1));
                            currMonthDay = (curDate.getMonth()+1)+"_"+curDate.getDate();
                            ht.push(" class='ub ub-f1 ub-fv'><div");
                            ht.push(" class='", this.settings.prevMonthCellClass," ", "'>");
                        }
                    } else {//下月
                        if (this.settings.prevNextMonthDaysVisible) {
                            var nextMonth = month;
                            var nextYear = year;
                            if (month == 12) {
                                nextMonth = 1;
                                nextYear = nextYear + 1;
                            }
                            else {
                                nextMonth = nextMonth + 1;
                            }
                            curDate = new Date(nextYear, nextMonth - 1, i - dayOfMonth - daysOfPrevMonth + 2);
                            currMonthDay = (curDate.getMonth()+1)+"_"+curDate.getDate();
                            ht.push(" class='ub ub-f1 ub-fv'><div");
                            ht.push(" class='", this.settings.nextMonthCellClass," ", "'>");
                        }
                    }
                    ht.push(curDate.getDate());
                    
                    ht.push("</div></div>");
                    //ht.push("</div>");
                    
                    if (i % 7 == 6) {//结束一行
                        ht.push("</div>");
                    }
                    if (i % 7 == 6 && dayOfMonth - 1 >= totalDays) {
                        break;
                    }
                }
                ht.push("</div>");
                return ht.join("");
            },
            
            //计算指定月的总天数
            _GetTotalDays: function(month, year) {
                if (month == 2) {
                    if (this._IsLeapYear(year)) {
                        return 29;
                    }
                    else {
                        return 28;
                    }
                }
                else if (month == 4 || month == 6 || month == 9 || month == 11) {
                    return 30;
                }
                else {
                    return 31;
                }
            },
            _GetToalDaysOfPrevMonth: function(month, year) {
                if (month == 1) {
                    month = 12;
                    year = year - 1;
                }
                else {
                    month = month - 1;
                }
                return this._GetTotalDays(month, year);
            },
            //判断是否是闰年
            _IsLeapYear: function(year) {
                return year % 400 == 0 || (year % 4 == 0 && year % 100 != 0);
            }
        };